<!-- Copyright 2008 - Jurie Botha -->

<?php
####################################################################################### 
# This tool comes with no warranty, use it at your own risk. Although I obviously did
# my best in making sure it works properly (and IT DOES!), I accept no responsibility
# for any damage caused by it. So, USE AT OWN RISK! (Don't worry too much - it DOES 
# work! :)  
#
# This software is licenced under the GNU GPL, and you may modify it to suit your needs!
# 
#######################################################################################
#
# Copyright: 2008 
#
# This file is part of IGNORAMUS.
#
#    IGNORAMUS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    IGNORAMUS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with IGNORAMUS.  If not, see <http://www.gnu.org/licenses/>.
# 
######################################################################################
# Where to Post ....

$self=$_SERVER["PHP_SELF"];

################################################################################################### 
# What to do....

$cmd=$_GET["cmd"];

################################################################################################### 
# Style...
$style="./style.css";



################################################################################################### 
#Variable Definition. 

$SERVICEGROUP_NAME=$_POST["servicegroup_name"];
$ALIAS=$_POST["alias"];
$DEFINE_MEMBERS=$_POST["define_members"];
$MEMBERS=$_POST["members"];
$DEFINE_SERVICEGROUP_MEMBERS=$_POST["define_servicegroup_members"];
$SERVICEGROUP_MEMBERS=$_POST["servicegroup_members"];
$NOTES=$_POST["notes"];
$NOTES_URL=$_POST["notes_url"];
$ACTION_URL=$_POST["action_url"];
$FILE=$_POST["file"];
$fail=$_POST["fail"];

################################################################################################### 
#Functions


function htmlhead() {
	global $style;
?>
<html>
<head>
<title>[IGNORAMUS]</title>
<link rel="stylesheet" type="text/css" href="<? echo $style ; ?>" />
</head>
<body>
<?php
}

function htmlfoot() {
?>
<br>
</body>
</html>
<?php
}

function writetofile() {
	global $FILE,$self,$fail,$SERVICEGROUP_NAME,$ALIAS,$DEFINE_MEMBERS,$MEMBERS,$DEFINE_SERVICEGROUP_MEMBERS,$SERVICEGROUP_MEMBERS,$NOTES,$NOTES_URL,$ACTION_URL,$FILE;

$fh = fopen($FILE,"a");

if (file_exists ($FILE) and is_writeable ($FILE)){

fwrite($fh,"# Generated by IGNORAMUS - The Nagios Config Generator! COPYRIGHT: 2008 - Jurie Botha");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"# Service Group definition for ");
fwrite($fh,$SERVICEGROUP_NAME);
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"define servicegroup{ ");
fwrite($fh,"\n");
if ( $SERVICEGROUP_NAME != "" ) {
fwrite($fh,"servicegroup_name          ");
fwrite($fh,$SERVICEGROUP_NAME);
fwrite($fh,"\n");
}
if ( $ALIAS != "" ) {
fwrite($fh,"alias                      ");
fwrite($fh,$ALIAS);
fwrite($fh,"\n");
}
if ( $DEFINE_MEMBERS == "on") { 
fwrite($fh,"members                    ");
fwrite($fh,$MEMBERS);
fwrite($fh,"\n");
}
if ( $DEFINE_SERVICEGROUP_MEMBERS == "on" ) {
fwrite($fh,"servicegroup_members       ");
fwrite($fh,$SERVICEGROUP_MEMBERS);
fwrite($fh,"\n");
}
if ( $NOTES != "") {
fwrite($fh,"notes                      ");
fwrite($fh,$NOTES);
fwrite($fh,"\n");
}
if ( $NOTES_URL != "") {
fwrite($fh,"notes_url                  ");
fwrite($fh,$NOTES_URL);
fwrite($fh,"\n");
}
if ( $ACTION_URL != "") {
fwrite($fh,"action_url                 ");
fwrite($fh,$ACTION_URL);
fwrite($fh,"\n");
}
fwrite($fh,"}");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fclose($fh);
}
?>
<?php
}

###################################################################################################################
# Form Design 

function printform() {
		global $FILE,$self,$fail,$SERVICEGROUP_NAME,$ALIAS,$DEFINE_MEMBERS,$MEMBERS,$DEFINE_SERVICEGROUP_MEMBERS,$SERVICEGROUP_MEMBERS,$NOTES,$NOTES_URL,$ACTION_URL,$FILE; 

		$formaction = "$self?cmd=post";
?>
	<form enctype="multipart/form-data" action="<?php echo "$formaction"; ?>" method="POST">
	<table>
	<tr>
	<td>
	<b>Servicegroup Name</b><br><small>(<i>Define a name for the servicegroup.</i>)</small></td><td><input type="text" name="servicegroup_name" value="<?php echo $SERVICEGROUP_NAME;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Alias:</b><br><small>(<i>Define an alias for the servicegroup.</i>)</small></td><td><input type="text" name="alias" value="<?php echo $ALIAS;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>	
	<b>Define Members:</b><br><small>(<i>Tick if you want to define members in servicegroups file.</i>)</small></td><td><input type="checkbox" name="define_members" <?php if ( $DEFINE_MEMBERS == "on" ) { echo "checked"; } ?>></td>
	</td>
	</tr>
	<tr>
	<td>
	<b>Group Members:</b><br><small>(<i>Only applicable if "Define Members" is ticked.</i>)</small></td><td><input type="text" name="members" value="<?php echo $MEMBERS;?>"></td>
	</tr>
	<tr>
	<td>
	<b>Define Subgroups:</b><br><small>(<i>Tick if you want to add other service groups to this group</i>)</small></td><td><input type="checkbox" name="define_servicegroup_members" <?php if ( $DEFINE_SERVICEGROUP_MEMBERS == "on" ) { echo "checked"; } ?>></td>
	</td>
	</tr>
	<tr>
	<td>
	<b>Subgroup Names:</b><br><small>(<i>Only applicable if "Define Servicegroups" is ticked.</i>)</small></td><td><input type="text" name="servicegroup_members" value="<?php echo $SERVICEGROUP_MEMBERS;?>"></td>
	</tr>
	<tr>
	<td>
	<b>Notes:</b><br><small>(<i>Insert any comments about Servicegroup here.</i>)</small></td><td><input type="text" name="notes" value="<?php echo $NOTES;?>"></td>
	</tr>
	<tr>
	<td>
	<b>Notes URL:</b><br><small>(<i>Input URL to additional notes about group here.</i>)</small></td><td><input type="text" name="notes_url" value="<?php echo $NOTES_URL;?>"></td>
	</tr>
	<tr>
	<td>
	<b>Action URL:</b><br><small>(<i>Input URL to additional actions for servicegroup here.</i>)</small></td><td><input type="text" name="action_url" value="<?php echo $ACTION_URL;?>"></td>
	</tr>
	<tr>
	<td>
	<b>File Path & Name:</b><br><small>(<i>Full path to file to append to.</i>)</small></td><td><input type="text" name="file" value="<?php echo $FILE;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	</table>
<table>
	<tr><td><input type="submit" value="Next ->" class="button" ></td><td><button name="reset" value="Reset / Clear" type="reset">Reset / Clear Form</button></td></tr>
</table>	
	
	</form>
<?php	

}

##################################################################################################################
# Check Dependencies



function genfiles() {
	global $FILE,$self,$fail,$SERVICEGROUP_NAME,$ALIAS,$DEFINE_MEMBERS,$MEMBERS,$DEFINE_SERVICEGROUP_MEMBERS,$SERVICEGROUP_MEMBERS,$NOTES,$NOTES_URL,$ACTION_URL;

	$formaction = "$self?cmd=post";
	
if ( $SERVICEGROUP_NAME == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>ServiceGroup Name is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}
	
if ( $ALIAS == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>Alias is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}	
	
	if ( $FILE == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>File Path & Name is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}	

##################################################################################################################
# Config Defifnition Script


	htmlhead();
	if ( $fail == 'true') {
		printform();
	} else {
		printservice();
		}
	
}

function printservice() {
	global $FILE,$self,$fail,$SERVICEGROUP_NAME,$ALIAS,$DEFINE_MEMBERS,$MEMBERS,$DEFINE_SERVICEGROUP_MEMBERS,$SERVICEGROUP_MEMBERS,$NOTES,$NOTES_URL,$ACTION_URL;
?>
<pre>
<?php

if (file_exists ($FILE) and is_writeable ($FILE) and $fail != 'true'){

writetofile();

echo '<font size="+3" color="blue"><b><u>Append Successfull!</u></font><font size="+1" color="blue"><i><br><br>New item successfully appended to file!</i></b></font>';

$file = $FILE;

if (file_exists ($file)){
  try {
    if ($readfile = fopen ($file, "r")){
      $curvalue = fread ($readfile,filesize($file));
          echo '<br><br><br><br><br><br>'.$curvalue;
       } else {
         	throw new exception ("Sorry, the file could not be opened.");
       }
     } catch (exception $e) {
       echo $e->getmessage();
     }
   } else {
     echo "File does not exist.";
   }
} else {
echo '<font size="+3" color="red"><b><u>Append Failed!</u></font><i><font size="+1" color="red"><br><br>File does not exist or apache does not have write access to it!</i></b></font>';
}
?>	
</pre>
<?php
}

################################################################################################################## 
# Generation Script


if ($cmd == "post") {
	htmlhead();
	genfiles();
	htmlfoot();
} else {
	htmlhead();
	?>
	<br>
	<p>
	<?php
	printform();
	htmlfoot();
}
?>