<!-- Copyright 2008 - Jurie Botha -->

<?php
####################################################################################### 
# This tool comes with no warranty, use it at your own risk. Although I obviously did
# my best in making sure it works properly (and IT DOES!), I accept no responsibility
# for any damage caused by it. So, USE AT OWN RISK! (Don't worry too much - it DOES 
# work! :)  
#
# This software is licenced under the GNU GPL, and you may modify it to suit your needs!
#  
#######################################################################################
#
# Copyright: 2008 
#
# This file is part of IGNORAMUS.
#
#    IGNORAMUS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    IGNORAMUS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with IGNORAMUS.  If not, see <http://www.gnu.org/licenses/>.
# 
######################################################################################
# Where to Post ....

$self=$_SERVER["PHP_SELF"];

################################################################################################### 
# What to do....

$cmd=$_GET["cmd"];

################################################################################################### 
# Style...
$style="./style.css";



################################################################################################### 
#Variable Definition. 

$FILE=$_POST["file"];
$host_name=$_POST["host_name"];
$hostgroup_name=$_POST["hostgroup_name"];
$service_description=$_POST["service_description"];
$contacts=$_POST["contacts"];
$contact_groups=$_POST["contact_groups"];
$first_notification=$_POST["first_notification"];
$last_notification=$_POST["last_notification"];
$notification_interval=$_POST["notification_interval"];
$escalation_period=$_POST["escalation_period"];
$ep_custom=$_POST["ep_custom"];
$escalation_options_u=$_POST["escalation_options_u"];
$escalation_options_d=$_POST["escalation_options_d"];
$escalation_options_r=$_POST["escalation_options_r"];
$fail=$_POST["fail"];


################################################################################################### 
#Functions


function htmlhead() {
	global $style;
?>
<html>
<head>
<title>[IGNORAMUS]</title>
<link rel="stylesheet" type="text/css" href="<? echo $style ; ?>" />
</head>
<body>
<?php
}

function htmlfoot() {
?>
</body>
</html>

<?php
}

function writetofile() {
	global $fail,$self,$ep_custom,$FILE,$host_name,$hostgroup_name,$contacts,$contact_groups,$first_notification,$last_notification,$notification_interval,$escalation_period,$escalation_options_u,$escalation_options_d,$escalation_options_r;

$fh = fopen($FILE,"a");

if (file_exists ($FILE) and is_writeable ($FILE)){

fwrite($fh,"# Generated by IGNORAMUS - The Nagios Config Generator! COPYRIGHT: 2008 - Jurie Botha");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"# Host Escalation Definition for ");
fwrite($fh,$host_name);
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"define hostescalation{");
fwrite($fh,"\n");
if ( $host_name != "" ) {
fwrite($fh,"host_name                     ");
fwrite($fh,$host_name);
fwrite($fh,"\n");
}
if ( $hostgroup_name != "" ) {
fwrite($fh,"hostgroup_name                ");
fwrite($fh,$hostgroup_name);
fwrite($fh,"\n");
}
if ( $contacts != "" ) {
fwrite($fh,"contacts                      ");
fwrite($fh,$contacts);
fwrite($fh,"\n");
}
if ( $contact_groups != "" ) {
fwrite($fh,"contact_groups                ");
fwrite($fh,$contact_groups);
fwrite($fh,"\n");
}
if ( $first_notification != "" ) {
fwrite($fh,"first_notification            ");
fwrite($fh,$first_notification);
fwrite($fh,"\n");
}
if ( $last_notification != "" ) {
fwrite($fh,"last_notification             ");
fwrite($fh,$last_notification);
fwrite($fh,"\n");
}
if ( $notification_interval != "" ) {
fwrite($fh,"notification_interval         ");
fwrite($fh,$notification_interval);
fwrite($fh,"\n");
}
if ( $escalation_period != "" and $escalation_period != "custom" ) {
fwrite($fh,"escalation_period             ");
fwrite($fh,$escalation_period);
fwrite($fh,"\n");
} else {
fwrite($fh,"escalation_period             ");
fwrite($fh,$ep_custom);
fwrite($fh,"\n");
}
fwrite($fh,"escalation_options            ");
if ( $escalation_options_r != "") {
fwrite($fh,"r");
}
if ( $escalation_options_r != "") {
fwrite($fh,",");
}
if ( $escalation_options_u != "") {
fwrite($fh,"u");
}
if ( $escalation_options_u != "") {
fwrite($fh,",");
}
if ( $escalation_options_d != "") {
fwrite($fh,"d");
}
fwrite($fh,"\n");
fwrite($fh,"}");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fclose($fh);
}
?>
<?php
}

###################################################################################################################
# Form Design 

function printform() {
		global $fail,$self,$ep_custom,$FILE,$host_name,$hostgroup_name,$contacts,$contact_groups,$first_notification,$last_notification,$notification_interval,$escalation_period,$escalation_options_u,$escalation_options_d,$escalation_options_r;

		$formaction = "$self?cmd=post";
?>
	<form enctype="multipart/form-data" action="<?php echo "$formaction"; ?>" method="POST">
	<table>
	<tr>
	<td>
	<b>Host Name:</b><br><small>(<i>Name of host that escalation applies to.</i>)</small></td><td><input type="text" name="host_name" value="<?php echo $host_name;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Hostgroup Name:</b><br><small>(<i>Name of hostgroup of host that escalation applies to.</i>)</small></td><td><input type="text" name="hostgroup_name" value="<?php echo $hostgroup_name;?>"></td>
	</tr>
	<tr>
	<td>
	<b>Contacts:</b><br><small>(<i>Which contacts will notifications be sent to.</i>)</small></td><td><input type="text" name="contacts" value="<?php echo $contacts;?>"><font size="1" color="ff0000"><b><i>*Required field if contact groups is blank.</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Contact Groups:</b><br><small>(<i>Which contact groups will notifications be sent to.</i>)</small></td><td><input type="text" name="contact_groups" value="<?php echo $contact_groups;?>"><font size="1" color="ff0000"><b><i>*Required field if contacts is blank.</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>First Notification:</b><br><small>(<i>After how many notifications does escalation take effect.</i>)</small></td><td><input type="text" name="first_notification" value="<?php echo $first_notification;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Last Notification:</b><br><small>(<i>For how many notifications will this escalation remain active.</i>)</small></td><td><input type="text" name="last_notification" value="<?php echo $last_notification;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Notification Interval:</b><br><small>(<i>How often will notifications be sent.</i>)</small></td><td><input type="text" name="notification_interval" value="<?php echo $notification_interval;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>
	<br><b>Escalation Period:</b></td><td><br>
	<select name="escalation_period" size=1>
	<option value="24x7">Eternally</option>
	<option value="workhours">During Workhours</option>
	<option value="nonworkhours">During Non-Workhours</option>
	<option value="none">Never</option>
	<option value="custom">--CUSTOM--</option>
	</select><br></td>
	</tr>
	<tr>
	<td>	
	<b>Custom Escalation Period:</b><br><small>(<i>If you have defined Timeperiods other than the ones listed,<br>and you want to use one of them, select --CUSTOM-- above and<br> enter the name here.</i>)</small></td><td><input type="text" name="ep_custom" value="<?php echo $ep_custom;?>"><font size="1" color="ff0000"><b><i>*Required field if custom is selected above.</i></b></font></td>
	</tr>
	<tr>
	<td>
	<br>
	<br>
	<b>Escalation Options:</b><br><small>(<i>Which states will trigger this escalation.</i>)</td><td>
		<br><input type="checkbox" name="escalation_options_u" <?php if ( $escalation_options_u == "on" ) { echo "checked"; } ?> > - UNREACHABLE
		<br><input type="checkbox" name="escalation_options_d" <?php if ( $escalation_options_d == "on" ) { echo "checked"; } ?> > - CRITICAL
		<br><input type="checkbox" name="escalation_options_r" <?php if ( $escalation_options_r == "on" ) { echo "checked"; } ?> > - RECOVERY
		<br><br>
	</td>
	</tr>
	<tr>
	<td>
	<b>File Path & Name:</b><br><small>(<i>Full path to file to append to.</i>)</small></td><td><input type="text" name="file" value="<?php echo $FILE;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	</table>
<table>
	<tr><td><input type="submit" value="Next ->" class="button" ></td><td><button name="reset" value="Reset / Clear" type="reset">Reset / Clear Form</button></td></tr>
</table>	
	
	</form>
<?php	

}

##################################################################################################################
# Check Dependencies



function genfiles() {
	global $fail,$self,$ep_custom,$FILE,$host_name,$hostgroup_name,$contacts,$contact_groups,$first_notification,$last_notification,$notification_interval,$escalation_period,$escalation_options_u,$escalation_options_d,$escalation_options_r;

	$formaction = "$self?cmd=post";
	
if ( $host_name == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>Host Name is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}
	
if ( $contacts == "" and $contact_groups == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>Contacts is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}

if ( $first_notification == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>First Notification is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}

if ( $last_notification == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>Last Notification is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}

if ( $notification_interval == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>Notification Interval is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}

if ( $escalation_period == "custom" and  $ep_custom == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>Custom Escalation Period is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}
	
	if ( $FILE == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>File Path & Name is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}

##################################################################################################################
# Config Defifnition Script


	htmlhead();
	if ( $fail == "true") {
		printform();
	} else {
		printhost();
		}
	
}

function printhost() {
	global $fail,$self,$ep_custom,$FILE,$host_name,$hostgroup_name,$contacts,$contact_groups,$first_notification,$last_notification,$notification_interval,$escalation_period,$escalation_options_u,$escalation_options_d,$escalation_options_r;
?>
<pre>
<?php

if (file_exists ($FILE) and is_writeable ($FILE) and $fail != 'true'){

writetofile();

echo '<font size="+3" color="blue"><b><u>Append Successfull!</u></font><font size="+1" color="blue"><i><br><br>New item successfully appended to file!</i></b></font>';

$file = $FILE;

if (file_exists ($file)){
  try {
    if ($readfile = fopen ($file, "r")){
      $curvalue = fread ($readfile,filesize($file));
          echo '<br><br><br><br><br><br>'.$curvalue;
       } else {
         	throw new exception ("Sorry, the file could not be opened.");
       }
     } catch (exception $e) {
       echo $e->getmessage();
     }
   } else {
     echo "File does not exist.";
   }
} else {
echo '<font size="+3" color="red"><b><u>Append Failed!</u></font><i><font size="+1" color="red"><br><br>File does not exist or apache does not have write access to it!</i></b></font>';
}
?>	
</pre>
<?php
}

################################################################################################################## 
# Generation Script


if ($cmd == "post") {
	htmlhead();
	genfiles();
	htmlfoot();
} else {
	htmlhead();
	?>
	<br>	
	<p>
	<?php
	printform();
	htmlfoot();
}
?>