<!-- Copyright 2008 - Jurie Botha -->

<?php 
####################################################################################### 
# This tool comes with no warranty, use it at your own risk. Although I obviously did
# my best in making sure it works properly (and IT DOES!), I accept no responsibility
# for any damage caused by it. So, USE AT OWN RISK! (Don't worry too much - it DOES 
# work! :)  
#
# This software is licenced under the GNU GPL, and you may modify it to suit your needs!
# 
#######################################################################################
#
# Copyright: 2008 
#
# This file is part of IGNORAMUS.
#
#    IGNORAMUS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    IGNORAMUS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with IGNORAMUS.  If not, see <http://www.gnu.org/licenses/>.
# 
######################################################################################
?>

<html>
<head>
<title></title>
</head>
<body marginwidth="8" marginheight="8">
<table>
<tr>
<td><font size="+2">IGNORAMUS 0.2.3 Release Notes</font></td>
</tr>
<tr>
<td>
<br>
<p>NB!! In order to use the "Append to File" Section, make sure that your apache user has write access to your Nagios Config directories.</p>
<br>
<br>
<p><font size="+1">Services Configuration Page</font></p>
</td>
</tr>
<tr>
<td>
<br>
<p>
In order to use the "Check DNS Resolvement" option in the "Check Command" section, you need to copy the "check_dns" plugin from the "3rd Party Plugins" page, and Add/Replace the following command to your commands.cfg file:
<br>
<br>
<font size="2"><br>
# Generated by IGNORAMUS - The Nagios Config Generator! COPYRIGHT: 2008 - Jurie Botha<br>
<br>
# Command definition for check_dns<br>
<br>
define command{<br>
command_name          check_dns<br>
command_line          $USER1$/check_dns -s $HOSTADDRESS$  -H $ARG1$ -w $ARG2$ -c $ARG3$<br>
}<br>
</font>
<br>
<br>
</p>
<p>
In order to use the "Check HP Server Status (Plugin A)" option in the "Check Command" section, you need to copy the "check_compaq_insight.pl" plugin from the "3rd Party Plugins" page, and Add/Replace the following command to your commands.cfg file:
<br>
<br>
<font size="2"><br>
# Generated by IGNORAMUS - The Nagios Config Generator! COPYRIGHT: 2008 - Jurie Botha<br>
<br>
# Command definition for check_hp_insight<br>
<br>
define command{<br>
command_name          check_hp_insight<br>
command_line          $USER1$/check_compaq_insight.pl -C public -H $HOSTADDRESS$<br>
}<br>
</font>
</p>
<br>
<p> 
In order to use the "Check NSCA Command Output" option you need to keep the folowing in mind:
<br>
<br>
<ul>
<li>You need NSCA Plugin installed and correctly configured on your Nagios Server.</li>
<li>You need a NSCA "client" installed and set up on the machine you want to monitor.</li>
<li>You need to add the following to your "commands.cfg" file:<br>
<br>
<font size="2">
# Generated by IGNORAMUS - The Nagios Config Generator! COPYRIGHT: 2008 - Jurie Botha<br>
<br>
# Command definition for check_dummy<br>
<br>
define command{<br>
command_name          check_dummy<br>
command_line          $USER1$/check_dummy $ARG1$<br>
}<br>
</font>
</li>
</ul>
</p>
<br>
<br>
<br>
</td>
</tr>
<tr>
<td><font size="+2">IGNORAMUS 0.2.2 Release Notes</font></td>
</tr>
<tr>
<td>
<br>
<p><font size="+1">Services Configuration Page</font></p>
<p>--> In order for "Check DCHP Leasing" option under "Check Commands" to work - replace the check_dhcp command in your commands.cfg file with this one: 
<br>
<br>
<font size="2"># 'check_dhcp' command definition <br>
define command{ <br>
command_name	check_dhcp <br>
command_line	$USER1$/check_dhcp -s $HOSTADDRESS$ -u -t 35 $ARG1$ <br>
}</font><br>
</p>
<p>--> In order for the "Check HP Printers" option under "Check Commands" to work, you need to enable SNMP on the printer you want to monitor. Enable the "public" community with READ ONLY access.
</p>
<br>
<p>--> In order to use the "SNMP Interface Checks" section under "Check Command" you need to download and install the "SNMP interface check" plugin from <a href="http://nagios.manubulon.com" target="_blank">http://nagios.manubulon.com</a>, as well as the "check_bandwidth" plugin by "Jonathan Wright" available from <a href="http://www.nagiosexchange.org">http://www.nagiosexchange.org</a>.
<br>
<br>
Also, You need to add the following commands to your commands.cfg file:
<br>
<br>
<font size="2">
# 'check_snmp_int_v1' command definition <br>

define command{ <br>
command_name    check_snmp_int_v1 <br>
command_line    $USER1$/check_snmp_int.pl -H $HOSTADDRESS$ -C public -2 -n $ARG1$ $ARG2$ <br>
} <br>
<br>
# 'check_snmp_int_v3' command definition <br>

define command{ <br>
command_name    check_snmp_int_v3 <br>
command_line    $USER1$/check_snmp_int.pl -H $HOSTADDRESS$ -l nagios -x password -n $ARG1$ $ARG2$ <br>
}<br>
<br>
# Check Bandwidth on a specified interface<br>
<br>
define command{<br>
        command_name    check_bandwidth<br>
        command_line    $USER1$/check_bandwidth -H $HOSTADDRESS$ -f -i $ARG1$ -w $ARG2$ -c $ARG3$ <br>
}<br>
</font>
</p>

</td>
</tr>
<tr>
<td></td>
</tr>
</table>
</body>
</html>