<!-- Copyright 2008 - Jurie Botha -->

<?php
####################################################################################### 
# This tool comes with no warranty, use it at your own risk. Although I obviously did
# my best in making sure it works properly (and IT DOES!), I accept no responsibility
# for any damage caused by it. So, USE AT OWN RISK! (Don't worry too much - it DOES 
# work! :)  
#
# This software is licenced under the GNU GPL, and you may modify it to suit your needs!
# 
#######################################################################################
#
# Copyright: 2008 
#
# This file is part of IGNORAMUS.
#
#    IGNORAMUS is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    IGNORAMUS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with IGNORAMUS.  If not, see <http://www.gnu.org/licenses/>.
# 
######################################################################################
# Where to Post ....

$self=$_SERVER["PHP_SELF"];

################################################################################################### 
# What to do....

$cmd=$_GET["cmd"];

################################################################################################### 
# Style...
$style="./style.css";



################################################################################################### 
#Variable Definition. 

$FILE="/usr/local/nagios/share/ignoramus/CFG/contactgroups.cfg";
$contactgroup_name=$_POST["contactgroup_name"];
$alias=$_POST["alias"];
$members=$_POST["members"];
$contactgroup_members=$_POST["contactgroup_members"];
$fail=$_POST["fail"];

################################################################################################### 
#Functions


function htmlhead() {
	global $style;
?>
<html>
<head>
<title>[IGNORAMUS]</title>
<link rel="stylesheet" type="text/css" href="<? echo $style ; ?>" />
</head>
<body>
<?php
}

function htmlfoot() {
?>
</body>
</html>

<?php
}

function writetofile() {
	global $self,$fail,$FILE,$contactgroup_name,$alias,$members,$contactgroup_members;

$fh = fopen($FILE,"a");

fwrite($fh,"# Generated by IGNORAMUS - The Nagios Config Generator! COPYRIGHT: 2008 - Jurie Botha");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"# ContactGroup definition for ");
fwrite($fh,$contactgroup_name);
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"define contactgroup{");
fwrite($fh,"\n");
if ( $contactgroup_name != "") {
fwrite($fh,"contactgroup_name          ");
fwrite($fh,$contactgroup_name);
fwrite($fh,"\n");
}
if ( $alias != "") {
fwrite($fh,"alias                      ");
fwrite($fh,$alias);
fwrite($fh,"\n");
}
if ( $members != "") {
fwrite($fh,"members                    ");
fwrite($fh,$members);
fwrite($fh,"\n");
}
if ( $contactgroup_members != "") {
fwrite($fh,"contactgroup_members       ");
fwrite($fh,$contactgroup_members);
fwrite($fh,"\n");
}
fwrite($fh,"}");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fwrite($fh,"\n");
fclose($fh);

?>
<?php
}

###################################################################################################################
# Form Design 

function printform() {
		global $fail,$self,$FILE,$contactgroup_name,$alias,$members,$contactgroup_members;

		$formaction = "$self?cmd=post";
?>
	<form enctype="multipart/form-data" action="<?php echo "$formaction"; ?>" method="POST">
	<table>
	<tr>
	<td>
	<b>ContactGroup Name:</b><br><small>(<i>Specify the name of the contact group.</i>)</small></td><td><input type="text" name="contactgroup_name" value="<?php echo $contactgroup_name;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Alias:</b><br><small>(<i>Specify an alias for the contactgroup.</i>)</small></td><td><input type="text" name="alias" value="<?php echo $alias;?>"><font size="1" color="ff0000"><b><i>*Required field</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Members:</b><br><small>(<i>Define contacts that are members of this group.</i>)</small></td><td><input type="text" name="members" value="<?php echo $members;?>"><font size="1" color="ff0000"><b><i>*Required field, alternatively - define members in the Contacts Page.</i></b></font></td>
	</tr>
	<tr>
	<td>
	<b>Sub-Group Members:</b><br><small>(<i>Define other contact groups that are members of this one.</i>)</small></td><td><input type="text" name="contactgroup_members" value="<?php echo $contactgroup_members;?>"></td>
	</tr>
	</table>
			<table>
				<tr><td><input type="submit" value="Next ->" class="button" ></td><td><button name="reset" value="Reset / Clear" type="reset">Reset / Clear Form</button></td></tr>
			</table>	
	
	</form>
<?php	

}

##################################################################################################################
# Check Dependencies



function genfiles() {
	global $fail,$self,$FILE,$contactgroup_name,$alias,$members,$contactgroup_members;

	$formaction = "$self?cmd=post";
	
if ( $contactgroup_name == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>ContactGroup Name is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}
	
if ( $alias == "" ) {
		echo '<font size="+1" color="ff0000"><b><i>Alias is Required, Please specify.</i></b></font><br><br>';
	$fail='true';
	}

##################################################################################################################
# Config Defifnition Script


	htmlhead();
	if ( $fail == 'true') {
		printform();
	} else {
		printhost();
		}
	
}

function printhost() {
	global $fail,$self,$FILE,$contactgroup_name,$alias,$members,$contactgroup_members;
?>
<pre>
<?php

if ($fail != 'true'){

writetofile();

echo '<font size="+3" color="blue"><b><u>File Generation Successfull!</u></font><font size="+1" color="blue"><i><br><br>New item successfully appended to file!</i></b></font>';

$file = $FILE;

if (file_exists ($file)){
  try {
    if ($readfile = fopen ($file, "r")){
      $curvalue = fread ($readfile,filesize($file));
          echo '<br><br><br><br><br><br>'.$curvalue;
       } else {
         	throw new exception ("Sorry, the file could not be opened.");
       }
     } catch (exception $e) {
       echo $e->getmessage();
     }
   } else {
     echo "File does not exist.";
   }
} else {
echo '<font size="+3" color="red"><b><u>Append Failed!</u></font><i><font size="+1" color="red"><br><br>File does not exist or apache does not have write access to it!</i></b></font>';
}
?>
</pre>
<?php
}

################################################################################################################## 
# Generation Script


if ($cmd == "post") {
	htmlhead();
	genfiles();
	htmlfoot();
} else {
	htmlhead();
	?>
	<br>
	<p>
	<?php
	printform();
	htmlfoot();
}
?>